diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/dsr/model/dsr-rcache.cc ns-3.39/src/dsr/model/dsr-rcache.cc
--- ns-3.38/src/dsr/model/dsr-rcache.cc	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/dsr/model/dsr-rcache.cc	2023-07-05 14:23:47.777427200 -0700
@@ -164,7 +164,6 @@
      */
     m_ntimer.SetDelay(m_delay);
     m_ntimer.SetFunction(&DsrRouteCache::PurgeMac, this);
-    m_txErrorCallback = MakeCallback(&DsrRouteCache::ProcessTxError, this);
 }
 
 DsrRouteCache::~DsrRouteCache()
@@ -220,100 +219,95 @@
     {
         return LookupRoute_Link(id, rt);
     }
-    else
+
+    Purge(); // Purge first to remove expired entries
+    if (m_sortedRoutes.empty())
     {
-        Purge(); // Purge first to remove expired entries
-        if (m_sortedRoutes.empty())
+        NS_LOG_LOGIC("Route to " << id << " not found; m_sortedRoutes is empty");
+        return false;
+    }
+    std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::const_iterator i =
+        m_sortedRoutes.find(id);
+    if (i == m_sortedRoutes.end())
+    {
+        NS_LOG_LOGIC("No Direct Route to " << id << " found");
+        for (std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::const_iterator j =
+                 m_sortedRoutes.begin();
+             j != m_sortedRoutes.end();
+             ++j)
         {
-            NS_LOG_LOGIC("Route to " << id << " not found; m_sortedRoutes is empty");
-            return false;
-        }
-        std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::const_iterator i =
-            m_sortedRoutes.find(id);
-        if (i == m_sortedRoutes.end())
-        {
-            NS_LOG_LOGIC("No Direct Route to " << id << " found");
-            for (std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::const_iterator j =
-                     m_sortedRoutes.begin();
-                 j != m_sortedRoutes.end();
-                 ++j)
+            std::list<DsrRouteCacheEntry> rtVector =
+                j->second; // The route cache vector linked with destination address
+            /*
+             * Loop through the possibly multiple routes within the route vector
+             */
+            for (std::list<DsrRouteCacheEntry>::const_iterator k = rtVector.begin();
+                 k != rtVector.end();
+                 ++k)
             {
-                std::list<DsrRouteCacheEntry> rtVector =
-                    j->second; // The route cache vector linked with destination address
-                /*
-                 * Loop through the possibly multiple routes within the route vector
-                 */
-                for (std::list<DsrRouteCacheEntry>::const_iterator k = rtVector.begin();
-                     k != rtVector.end();
-                     ++k)
-                {
-                    // return the first route in the route vector
-                    DsrRouteCacheEntry::IP_VECTOR routeVector = k->GetVector();
-                    DsrRouteCacheEntry::IP_VECTOR changeVector;
-
-                    for (DsrRouteCacheEntry::IP_VECTOR::iterator l = routeVector.begin();
-                         l != routeVector.end();
-                         ++l)
-                    {
-                        if (*l != id)
-                        {
-                            changeVector.push_back(*l);
-                        }
-                        else
-                        {
-                            changeVector.push_back(*l);
-                            break;
-                        }
-                    }
-                    /*
-                     * When the changed vector is smaller in size and larger than 1, which means we
-                     * have found a route with the destination address we are looking for
-                     */
-                    if ((changeVector.size() < routeVector.size()) && (changeVector.size() > 1))
+                // return the first route in the route vector
+                DsrRouteCacheEntry::IP_VECTOR routeVector = k->GetVector();
+                DsrRouteCacheEntry::IP_VECTOR changeVector;
+
+                for (DsrRouteCacheEntry::IP_VECTOR::iterator l = routeVector.begin();
+                     l != routeVector.end();
+                     ++l)
+                {
+                    changeVector.push_back(*l);
+
+                    if (*l == id)
                     {
-                        DsrRouteCacheEntry changeEntry; // Create the route entry
-                        changeEntry.SetVector(changeVector);
-                        changeEntry.SetDestination(id);
-                        // Use the expire time from original route entry
-                        changeEntry.SetExpireTime(k->GetExpireTime());
-                        // We need to add new route entry here
-                        std::list<DsrRouteCacheEntry> newVector;
-                        newVector.push_back(changeEntry);
-                        newVector.sort(CompareRoutesExpire); // sort the route vector first
-                        m_sortedRoutes[id] =
-                            newVector; // Only get the first sub route and add it in route cache
-                        NS_LOG_INFO("We have a sub-route to " << id << " add it in route cache");
+                        break;
                     }
                 }
+                /*
+                 * When the changed vector is smaller in size and larger than 1, which means we
+                 * have found a route with the destination address we are looking for
+                 */
+                if ((changeVector.size() < routeVector.size()) && (changeVector.size() > 1))
+                {
+                    DsrRouteCacheEntry changeEntry; // Create the route entry
+                    changeEntry.SetVector(changeVector);
+                    changeEntry.SetDestination(id);
+                    // Use the expire time from original route entry
+                    changeEntry.SetExpireTime(k->GetExpireTime());
+                    // We need to add new route entry here
+                    std::list<DsrRouteCacheEntry> newVector;
+                    newVector.push_back(changeEntry);
+                    newVector.sort(CompareRoutesExpire); // sort the route vector first
+                    m_sortedRoutes[id] =
+                        newVector; // Only get the first sub route and add it in route cache
+                    NS_LOG_INFO("We have a sub-route to " << id << " add it in route cache");
+                }
             }
         }
-        NS_LOG_INFO("Here we check the route cache again after updated the sub routes");
-        std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::const_iterator m =
-            m_sortedRoutes.find(id);
-        if (m == m_sortedRoutes.end())
-        {
-            NS_LOG_LOGIC("No updated route till last time");
-            return false;
-        }
-        /*
-         * We have a direct route to the destination address
-         */
-        std::list<DsrRouteCacheEntry> rtVector = m->second;
-        rt = rtVector.front(); // use the first entry in the route vector
-        NS_LOG_LOGIC("Route to " << id << " with route size " << rtVector.size());
-        return true;
     }
+    NS_LOG_INFO("Here we check the route cache again after updated the sub routes");
+    std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::const_iterator m =
+        m_sortedRoutes.find(id);
+    if (m == m_sortedRoutes.end())
+    {
+        NS_LOG_LOGIC("No updated route till last time");
+        return false;
+    }
+    /*
+     * We have a direct route to the destination address
+     */
+    std::list<DsrRouteCacheEntry> rtVector = m->second;
+    rt = rtVector.front(); // use the first entry in the route vector
+    NS_LOG_LOGIC("Route to " << id << " with route size " << rtVector.size());
+    return true;
 }
 
 void
 DsrRouteCache::SetCacheType(std::string type)
 {
     NS_LOG_FUNCTION(this << type);
-    if (type == std::string("LinkCache"))
+    if (type == "LinkCache")
     {
         m_isLinkCache = true;
     }
-    else if (type == std::string("PathCache"))
+    else if (type == "PathCache")
     {
         m_isLinkCache = false;
     }
@@ -442,13 +436,7 @@
             }
             route.push_back(source);
             // Reverse the route
-            DsrRouteCacheEntry::IP_VECTOR reverseroute;
-            for (DsrRouteCacheEntry::IP_VECTOR::reverse_iterator j = route.rbegin();
-                 j != route.rend();
-                 ++j)
-            {
-                reverseroute.push_back(*j);
-            }
+            DsrRouteCacheEntry::IP_VECTOR reverseroute(route.rbegin(), route.rend());
             NS_LOG_LOGIC("Add newly calculated best routes");
             PrintVector(reverseroute);
             m_bestRoutesTable_link[i->first] = reverseroute;
@@ -469,24 +457,22 @@
         NS_LOG_INFO("No route find to " << id);
         return false;
     }
-    else
-    {
-        if (i->second.size() < 2)
-        {
-            NS_LOG_LOGIC("Route to " << id << " error");
-            return false;
-        }
 
-        DsrRouteCacheEntry newEntry; // Create the route entry
-        newEntry.SetVector(i->second);
-        newEntry.SetDestination(id);
-        newEntry.SetExpireTime(RouteCacheTimeout);
-        NS_LOG_INFO("Route to " << id << " found with the length " << i->second.size());
-        rt = newEntry;
-        std::vector<Ipv4Address> path = rt.GetVector();
-        PrintVector(path);
-        return true;
+    if (i->second.size() < 2)
+    {
+        NS_LOG_LOGIC("Route to " << id << " error");
+        return false;
     }
+
+    DsrRouteCacheEntry newEntry; // Create the route entry
+    newEntry.SetVector(i->second);
+    newEntry.SetDestination(id);
+    newEntry.SetExpireTime(RouteCacheTimeout);
+    NS_LOG_INFO("Route to " << id << " found with the length " << i->second.size());
+    rt = newEntry;
+    std::vector<Ipv4Address> path = rt.GetVector();
+    PrintVector(path);
+    return true;
 }
 
 void
@@ -710,55 +696,54 @@
             m_sortedRoutes.insert(std::make_pair(dst, rtVector));
         return result.second;
     }
-    else
+
+    rtVector = i->second;
+    NS_LOG_DEBUG("The existing route size " << rtVector.size() << " for destination address "
+                                            << dst);
+    /**
+     * \brief Drop the most aged packet when buffer reaches to max
+     */
+    if (rtVector.size() >= m_maxEntriesEachDst)
     {
-        rtVector = i->second;
-        NS_LOG_DEBUG("The existing route size " << rtVector.size() << " for destination address "
-                                                << dst);
-        /**
-         * \brief Drop the most aged packet when buffer reaches to max
-         */
-        if (rtVector.size() >= m_maxEntriesEachDst)
-        {
-            RemoveLastEntry(rtVector); // Drop the last entry for the sorted route cache, the route
-                                       // has already been sorted
-        }
+        RemoveLastEntry(rtVector); // Drop the last entry for the sorted route cache, the route
+                                   // has already been sorted
+    }
 
-        if (FindSameRoute(rt, rtVector))
+    if (FindSameRoute(rt, rtVector))
+    {
+        NS_LOG_DEBUG(
+            "Find same vector, the FindSameRoute function will update the route expire time");
+        return true;
+    }
+    else
+    {
+        // Check if the expire time for the new route has expired or not
+        if (rt.GetExpireTime() > Time(0))
         {
-            NS_LOG_DEBUG(
-                "Find same vector, the FindSameRoute function will update the route expire time");
-            return true;
+            rtVector.push_back(rt);
+            // This sort function will sort the route cache entries based on the size of route
+            // in each of the route entries
+            rtVector.sort(CompareRoutesExpire);
+            NS_LOG_DEBUG("The first time" << rtVector.front().GetExpireTime().As(Time::S)
+                                          << " The second time "
+                                          << rtVector.back().GetExpireTime().As(Time::S));
+            NS_LOG_DEBUG("The first hop" << rtVector.front().GetVector().size()
+                                         << " The second hop "
+                                         << rtVector.back().GetVector().size());
+            m_sortedRoutes.erase(dst); // erase the route entries for dst first
+            /**
+             * Save the new route cache along with the destination address in map
+             */
+            std::pair<std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::iterator, bool> result =
+                m_sortedRoutes.insert(std::make_pair(dst, rtVector));
+            return result.second;
         }
         else
         {
-            // Check if the expire time for the new route has expired or not
-            if (rt.GetExpireTime() > Time(0))
-            {
-                rtVector.push_back(rt);
-                // This sort function will sort the route cache entries based on the size of route
-                // in each of the route entries
-                rtVector.sort(CompareRoutesExpire);
-                NS_LOG_DEBUG("The first time" << rtVector.front().GetExpireTime().As(Time::S)
-                                              << " The second time "
-                                              << rtVector.back().GetExpireTime().As(Time::S));
-                NS_LOG_DEBUG("The first hop" << rtVector.front().GetVector().size()
-                                             << " The second hop "
-                                             << rtVector.back().GetVector().size());
-                m_sortedRoutes.erase(dst); // erase the route entries for dst first
-                /**
-                 * Save the new route cache along with the destination address in map
-                 */
-                std::pair<std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::iterator, bool>
-                    result = m_sortedRoutes.insert(std::make_pair(dst, rtVector));
-                return result.second;
-            }
-            else
-            {
-                NS_LOG_INFO("The newly found route is already expired");
-            }
+            NS_LOG_INFO("The newly found route is already expired");
         }
     }
+
     return false;
 }
 
@@ -897,15 +882,12 @@
                     }
                     else
                     {
+                        changeVector.push_back(*i);
+
                         if (*(i + 1) == unreachNode)
                         {
-                            changeVector.push_back(*i);
                             break;
                         }
-                        else
-                        {
-                            changeVector.push_back(*i);
-                        }
                     }
                 }
                 /*
@@ -1109,14 +1091,12 @@
         m_ackIdCache[nextHop] = 1;
         return 1;
     }
-    else
-    {
-        uint16_t ackId = m_ackIdCache[nextHop];
-        NS_LOG_LOGIC("Ack id for " << nextHop << " found in the cache has value " << ackId);
-        ackId++;
-        m_ackIdCache[nextHop] = ackId;
-        return ackId;
-    }
+
+    uint16_t ackId = m_ackIdCache[nextHop];
+    NS_LOG_LOGIC("Ack id for " << nextHop << " found in the cache has value " << ackId);
+    ackId++;
+    m_ackIdCache[nextHop] = ackId;
+    return ackId;
 }
 
 uint16_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/dsr/model/dsr-rcache.h ns-3.39/src/dsr/model/dsr-rcache.h
--- ns-3.38/src/dsr/model/dsr-rcache.h	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/dsr/model/dsr-rcache.h	2023-07-05 14:23:47.777427200 -0700
@@ -767,16 +767,6 @@
     void DelArpCache(Ptr<ArpCache>);
 
     /**
-     * \brief Get callback to ProcessTxError, this callback is trying to use the wifi mac tx error
-     * header to notify a link layer drop event, however, it is not fully supported yet
-     * \return The callback to ProcessTxError
-     */
-    Callback<void, const WifiMacHeader&> GetTxErrorCallback() const
-    {
-        return m_txErrorCallback;
-    }
-
-    /**
      * Handle link failure callback
      * \param cb the callback to be set
      */
@@ -912,8 +902,6 @@
      */
     Callback<void, Ipv4Address, uint8_t> m_handleLinkFailure; ///< link failure callback
 
-    Callback<void, const WifiMacHeader&> m_txErrorCallback; ///< TX error callback
-
     Timer m_ntimer; ///< Timer for neighbor's list. Schedule Purge().
 
     std::vector<Neighbor> m_nb; ///< vector of entries
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/dsr/model/dsr-routing.cc ns-3.39/src/dsr/model/dsr-routing.cc
--- ns-3.38/src/dsr/model/dsr-routing.cc	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/dsr/model/dsr-routing.cc	2023-07-05 14:23:47.777427200 -0700
@@ -579,8 +579,6 @@
                 Ptr<AdhocWifiMac> adhoc = mac->GetObject<AdhocWifiMac>();
                 if (adhoc)
                 {
-                    adhoc->TraceDisconnectWithoutContext("TxErrHeader",
-                                                         m_routeCache->GetTxErrorCallback());
                     m_routeCache->DelArpCache(m_ipv4->GetInterface(i)->GetArpCache());
                 }
             }
@@ -769,23 +767,22 @@
         nextHop = vec[1];
         return nextHop;
     }
-    else
+
+    if (ipv4Address == vec.back())
+    {
+        NS_LOG_DEBUG("We have reached to the final destination " << ipv4Address << " "
+                                                                 << vec.back());
+        return ipv4Address;
+    }
+    for (std::vector<Ipv4Address>::const_iterator i = vec.begin(); i != vec.end(); ++i)
     {
-        if (ipv4Address == vec.back())
+        if (ipv4Address == (*i))
         {
-            NS_LOG_DEBUG("We have reached to the final destination " << ipv4Address << " "
-                                                                     << vec.back());
-            return ipv4Address;
-        }
-        for (std::vector<Ipv4Address>::const_iterator i = vec.begin(); i != vec.end(); ++i)
-        {
-            if (ipv4Address == (*i))
-            {
-                nextHop = *(++i);
-                return nextHop;
-            }
+            nextHop = *(++i);
+            return nextHop;
         }
     }
+
     NS_LOG_DEBUG("Next hop address not found");
     Ipv4Address none = "0.0.0.0";
     return none;
@@ -833,12 +830,10 @@
         NS_LOG_DEBUG("Exceed the node range");
         return "0.0.0.0";
     }
-    else
-    {
-        Ptr<Node> node = NodeList::GetNode(uint32_t(id));
-        Ptr<Ipv4> ipv4 = node->GetObject<Ipv4>();
-        return ipv4->GetAddress(1, 0).GetLocal();
-    }
+
+    Ptr<Node> node = NodeList::GetNode(uint32_t(id));
+    Ptr<Ipv4> ipv4 = node->GetObject<Ipv4>();
+    return ipv4->GetAddress(1, 0).GetLocal();
 }
 
 uint32_t
@@ -3035,7 +3030,6 @@
             SendPacketFromBuffer(sourceRoute, nextHop, protocol);
         }
         NS_LOG_LOGIC("Route to " << dst << " found");
-        return;
     }
     else
     {
@@ -3535,7 +3529,7 @@
     }
 }
 
-enum IpL4Protocol::RxStatus
+IpL4Protocol::RxStatus
 DsrRouting::Receive(Ptr<Packet> p, const Ipv4Header& ip, Ptr<Ipv4Interface> incomingInterface)
 {
     NS_LOG_FUNCTION(this << p << ip << incomingInterface);
@@ -3660,7 +3654,7 @@
         optionLength =
             dsrOption
                 ->Process(p, packet, m_mainAddress, source, ip, protocol, isPromisc, promiscSource);
-        segmentsLeft = *(data + 3);
+        segmentsLeft = data[3];
         if (optionLength == 0)
         {
             NS_LOG_INFO("Discard this packet");
@@ -3674,36 +3668,32 @@
                 uint8_t nextHeader = dsrRoutingHeader.GetNextHeader();
                 Ptr<Ipv4L3Protocol> l3proto = m_node->GetObject<Ipv4L3Protocol>();
                 Ptr<IpL4Protocol> nextProto = l3proto->GetProtocol(nextHeader);
-                if (nextProto)
+                if (!nextProto)
                 {
-                    // we need to make a copy in the unlikely event we hit the
-                    // RX_ENDPOINT_UNREACH code path
-                    // Here we can use the packet that has been get off whole DSR header
-                    enum IpL4Protocol::RxStatus status =
-                        nextProto->Receive(copy, ip, incomingInterface);
-                    NS_LOG_DEBUG("The receive status " << status);
-                    switch (status)
-                    {
-                    case IpL4Protocol::RX_OK:
-                    // fall through
-                    case IpL4Protocol::RX_ENDPOINT_CLOSED:
-                    // fall through
-                    case IpL4Protocol::RX_CSUM_FAILED:
-                        break;
-                    case IpL4Protocol::RX_ENDPOINT_UNREACH:
-                        if (ip.GetDestination().IsBroadcast() == true ||
-                            ip.GetDestination().IsMulticast() == true)
-                        {
-                            break; // Do not reply to broadcast or multicast
-                        }
-                        // Another case to suppress ICMP is a subnet-directed broadcast
-                    }
-                    return status;
+                    NS_FATAL_ERROR("Should not have 0 next protocol value");
                 }
-                else
+
+                // we need to make a copy in the unlikely event we hit the
+                // RX_ENDPOINT_UNREACH code path
+                // Here we can use the packet that has been get off whole DSR header
+                IpL4Protocol::RxStatus status = nextProto->Receive(copy, ip, incomingInterface);
+                NS_LOG_DEBUG("The receive status " << status);
+                switch (status)
                 {
-                    NS_FATAL_ERROR("Should not have 0 next protocol value");
+                case IpL4Protocol::RX_OK:
+                // fall through
+                case IpL4Protocol::RX_ENDPOINT_CLOSED:
+                // fall through
+                case IpL4Protocol::RX_CSUM_FAILED:
+                    break;
+                case IpL4Protocol::RX_ENDPOINT_UNREACH:
+                    if (ip.GetDestination().IsBroadcast() || ip.GetDestination().IsMulticast())
+                    {
+                        break; // Do not reply to broadcast or multicast
+                    }
+                    // Another case to suppress ICMP is a subnet-directed broadcast
                 }
+                return status;
             }
             else
             {
@@ -3720,26 +3710,26 @@
          */
         uint8_t salvage = 0;
 
-        DsrOptionRerrUnsupportHeader rerrUnsupportHeader;
-        rerrUnsupportHeader.SetErrorType(3); // The error type 3 means Option not supported
-        rerrUnsupportHeader.SetErrorSrc(
+        DsrOptionRerrUnsupportedHeader rerrUnsupportedHeader;
+        rerrUnsupportedHeader.SetErrorType(3); // The error type 3 means Option not supported
+        rerrUnsupportedHeader.SetErrorSrc(
             m_mainAddress); // The error source address is our own address
-        rerrUnsupportHeader.SetUnsupported(optionType); // The unsupported option type number
-        rerrUnsupportHeader.SetErrorDst(
+        rerrUnsupportedHeader.SetUnsupported(optionType); // The unsupported option type number
+        rerrUnsupportedHeader.SetErrorDst(
             src); // Error destination address is the destination of the data packet
-        rerrUnsupportHeader.SetSalvage(
+        rerrUnsupportedHeader.SetSalvage(
             salvage); // Set the value about whether to salvage a packet or not
 
         /*
          * The unknown option error is not supported currently in this implementation, and it's also
          * not likely to happen in simulations
          */
-        //            SendError (rerrUnsupportHeader, 0, protocol); // Send the error packet
+        //            SendError (rerrUnsupportedHeader, 0, protocol); // Send the error packet
     }
     return IpL4Protocol::RX_OK;
 }
 
-enum IpL4Protocol::RxStatus
+IpL4Protocol::RxStatus
 DsrRouting::Receive(Ptr<Packet> p, const Ipv6Header& ip, Ptr<Ipv6Interface> incomingInterface)
 {
     NS_LOG_FUNCTION(this << p << ip.GetSource() << ip.GetDestination() << incomingInterface);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/dsr/model/dsr-routing.h ns-3.39/src/dsr/model/dsr-routing.h
--- ns-3.38/src/dsr/model/dsr-routing.h	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/dsr/model/dsr-routing.h	2023-07-05 14:23:47.777427200 -0700
@@ -644,9 +644,9 @@
      * Called from lower-level layers to send the packet up
      * in the stack.
      */
-    enum IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
-                                        const Ipv4Header& header,
-                                        Ptr<Ipv4Interface> incomingInterface) override;
+    IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
+                                   const Ipv4Header& header,
+                                   Ptr<Ipv4Interface> incomingInterface) override;
 
     /**
      * \param p packet to forward up
@@ -657,9 +657,9 @@
      * Called from lower-level layers to send the packet up
      * in the stack.  Not implemented (IPv6).
      */
-    enum IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
-                                        const Ipv6Header& header,
-                                        Ptr<Ipv6Interface> incomingInterface) override;
+    IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
+                                   const Ipv6Header& header,
+                                   Ptr<Ipv6Interface> incomingInterface) override;
 
     void SetDownTarget(IpL4Protocol::DownTargetCallback callback) override;
     void SetDownTarget6(IpL4Protocol::DownTargetCallback6 callback) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/dsr/model/dsr-rreq-table.cc ns-3.39/src/dsr/model/dsr-rreq-table.cc
--- ns-3.38/src/dsr/model/dsr-rreq-table.cc	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/dsr/model/dsr-rreq-table.cc	2023-07-05 14:23:47.777427200 -0700
@@ -145,11 +145,9 @@
         NS_LOG_LOGIC("Request table entry not found");
         return 0;
     }
-    else
-    {
-        RreqTableEntry rreqTableEntry = i->second;
-        return rreqTableEntry.m_reqNo;
-    }
+
+    RreqTableEntry rreqTableEntry = i->second;
+    return rreqTableEntry.m_reqNo;
 }
 
 // ----------------------------------------------------------------------------------------------------------
@@ -168,25 +166,23 @@
         m_rreqIdCache[dst] = 0;
         return 0;
     }
+
+    NS_LOG_LOGIC("Request id for " << dst << " found in the cache");
+    uint32_t rreqId = m_rreqIdCache[dst];
+    if (rreqId >= m_maxRreqId)
+    {
+        NS_LOG_DEBUG("The request id increase past the max value, " << m_maxRreqId
+                                                                    << " so reset it to 0");
+        rreqId = 0;
+        m_rreqIdCache[dst] = rreqId;
+    }
     else
     {
-        NS_LOG_LOGIC("Request id for " << dst << " found in the cache");
-        uint32_t rreqId = m_rreqIdCache[dst];
-        if (rreqId >= m_maxRreqId)
-        {
-            NS_LOG_DEBUG("The request id increase past the max value, " << m_maxRreqId
-                                                                        << " so reset it to 0");
-            rreqId = 0;
-            m_rreqIdCache[dst] = rreqId;
-        }
-        else
-        {
-            rreqId++;
-            m_rreqIdCache[dst] = rreqId;
-        }
-        NS_LOG_INFO("The Request id for " << dst << " is " << rreqId);
-        return rreqId;
+        rreqId++;
+        m_rreqIdCache[dst] = rreqId;
     }
+    NS_LOG_INFO("The Request id for " << dst << " is " << rreqId);
+    return rreqId;
 }
 
 uint32_t
@@ -276,35 +272,32 @@
         m_sourceRreqMap[src] = receivedRreqEntryList;
         return false;
     }
-    else
+
+    NS_LOG_LOGIC("Find the request table entry for  " << src << ", check if it is exact duplicate");
+    /*
+     * Drop the most aged packet when buffer reaches to max
+     */
+    receivedRreqEntryList = i->second;
+    if (receivedRreqEntryList.size() >= m_requestIdSize)
     {
-        NS_LOG_LOGIC("Find the request table entry for  " << src
-                                                          << ", check if it is exact duplicate");
-        /*
-         * Drop the most aged packet when buffer reaches to max
-         */
-        receivedRreqEntryList = i->second;
-        if (receivedRreqEntryList.size() >= m_requestIdSize)
-        {
-            receivedRreqEntryList.pop_front();
-        }
-        Ipv4Address src = i->first;
-        // We loop the receive rreq entry to find duplicate
-        for (std::list<DsrReceivedRreqEntry>::const_iterator j = receivedRreqEntryList.begin();
-             j != receivedRreqEntryList.end();
-             ++j)
+        receivedRreqEntryList.pop_front();
+    }
+
+    // We loop the receive rreq entry to find duplicate
+    for (std::list<DsrReceivedRreqEntry>::const_iterator j = receivedRreqEntryList.begin();
+         j != receivedRreqEntryList.end();
+         ++j)
+    {
+        if (*j == rreqEntry) /// Check if we have found one duplication entry or not
         {
-            if (*j == rreqEntry) /// Check if we have found one duplication entry or not
-            {
-                return true;
-            }
+            return true;
         }
-        /// if this entry is not found, we need to save the entry in the cache, and then return
-        /// false for the check
-        receivedRreqEntryList.push_back(rreqEntry);
-        m_sourceRreqMap[src] = receivedRreqEntryList;
-        return false;
     }
+    /// if this entry is not found, we need to save the entry in the cache, and then return
+    /// false for the check
+    receivedRreqEntryList.push_back(rreqEntry);
+    m_sourceRreqMap[src] = receivedRreqEntryList;
+    return false;
 }
 
 } // namespace dsr
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/dsr/model/dsr-rreq-table.h ns-3.39/src/dsr/model/dsr-rreq-table.h
--- ns-3.38/src/dsr/model/dsr-rreq-table.h	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/dsr/model/dsr-rreq-table.h	2023-07-05 14:23:47.777427200 -0700
@@ -408,7 +408,7 @@
          * \param b BlackList entry
          * \return true if expired, false otherwise
          */
-        bool operator()(const struct BlackList& b) const
+        bool operator()(const BlackList& b) const
         {
             return (b.m_expireTime < Simulator::Now());
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/energy/helper/energy-source-container.h ns-3.39/src/energy/helper/energy-source-container.h
--- ns-3.38/src/energy/helper/energy-source-container.h	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/energy/helper/energy-source-container.h	2023-07-05 14:23:47.785427300 -0700
@@ -63,7 +63,7 @@
     /**
      * \param source Pointer to an EnergySource.
      *
-     * Creates an EnergySourceContianer with exactly one EnergySource previously
+     * Creates an EnergySourceContainer with exactly one EnergySource previously
      * instantiated.
      */
     EnergySourceContainer(Ptr<EnergySource> source);
